Submitted By: Robert Connolly <robert at linuxfromscratch dot org>
Date: 2003-08-30
Initial Package Version: 3.3.4
Upstream Status: Not submitted - LFS Specific
Origin: Originally developed for GCC 3.2 by
	Greg Schafer <gschafer at zip dot com dot au>
Description: Prevent fixincludes script from running.

diff -Naur gcc-3.3.4.orig/gcc/Makefile.in gcc-3.3.4.nofixincludes/gcc/Makefile.in
--- gcc-3.3.4.orig/gcc/Makefile.in	2004-04-01 16:55:23.000000000 +0000
+++ gcc-3.3.4.nofixincludes/gcc/Makefile.in	2004-08-30 20:01:21.000000000 +0000
@@ -2341,10 +2341,6 @@
 	rm -f include/limits.h
 	cp xlimits.h include/limits.h
 	chmod a+r include/limits.h
-# Install the README
-	rm -f include/README
-	cp $(srcdir)/README-fixinc include/README
-	chmod a+r include/README
 	$(STAMP) $@
 
 # fixinc.sh depends on this, not on specs directly.
@@ -2386,7 +2382,6 @@
 	(TARGET_MACHINE='$(target)'; srcdir=`cd $(srcdir); ${PWD_COMMAND}`; \
 	SHELL='$(SHELL)' ;\
 	export TARGET_MACHINE srcdir SHELL ; \
-	$(SHELL) ./fixinc.sh `${PWD_COMMAND}`/include $(SYSTEM_HEADER_DIR) $(OTHER_FIXINCLUDES_DIRS); \
 	rm -f include/syslimits.h; \
 	if [ -f include/limits.h ]; then \
 	  mv include/limits.h include/syslimits.h; \