Submitted By: LFS PATCH
Date: 2004-09-06
Initial Package Version: 3.4.2
Upstream Status: Not Sent - LFS Specfic
Origin: Originally developed for GCC 3.2 by Greg Schafer and Zack Winkles
Description: Prevent fixincludes script from running.

diff -Naur gcc-3.4.2.orig/gcc/Makefile.in gcc-3.4.2/gcc/Makefile.in
--- gcc-3.4.2.orig/gcc/Makefile.in	2004-06-17 21:56:58.000000000 +0000
+++ gcc-3.4.2/gcc/Makefile.in	2004-09-07 13:41:31.982711800 +0000
@@ -2478,10 +2478,6 @@
 	rm -f include/limits.h
 	cp xlimits.h include/limits.h
 	chmod a+r include/limits.h
-# Install the README
-	rm -f include/README
-	cp $(srcdir)/README-fixinc include/README
-	chmod a+r include/README
 	$(STAMP) $@
 
 # fixinc.sh depends on this, not on specs directly.
@@ -2527,7 +2523,6 @@
 	(TARGET_MACHINE='$(target)'; srcdir=`cd $(srcdir); ${PWD_COMMAND}`; \
 	SHELL='$(SHELL)' ;\
 	export TARGET_MACHINE srcdir SHELL ; \
-	$(SHELL) ./fixinc.sh `${PWD_COMMAND}`/include $(SYSTEM_HEADER_DIR) $(OTHER_FIXINCLUDES_DIRS); \
 	rm -f include/syslimits.h; \
 	if [ -f include/limits.h ]; then \
 	  mv include/limits.h include/syslimits.h; \