Submitted By: Jim Gifford (jim at linuxfromscratch dot org)
Date: 2004-09-06
Initial Package Version: 3.4.2
Origin: Jim Gifford
Upstream Status: Not Accepted - Alternative to be made
Description: Fixes all POSIX issues
 
diff -Naur gcc-3.4.2.orig/contrib/test_summary gcc-3.4.2/contrib/test_summary
--- gcc-3.4.2.orig/contrib/test_summary	2004-08-26 05:49:13.000000000 +0000
+++ gcc-3.4.2/contrib/test_summary	2004-09-07 13:55:31.927020856 +0000
@@ -106,7 +106,7 @@
     srcdir = configflags;
     sub(/\/configure .*/, "", srcdir);
     printf "LAST_UPDATED: ";
-    system("tail -1 " srcdir "/LAST_UPDATED");
+    system("tail -n 1 " srcdir "/LAST_UPDATED");
     print "";
 
     sub(/^[^ ]*\/configure */, " ", configflags);
diff -Naur gcc-3.4.2.orig/gcc/configure gcc-3.4.2/gcc/configure
--- gcc-3.4.2.orig/gcc/configure	2004-07-13 06:58:29.000000000 +0000
+++ gcc-3.4.2/gcc/configure	2004-09-07 13:55:32.022006416 +0000
@@ -10127,7 +10127,7 @@
   # and we got the correct data, then succeed.
   if test x$gcc_cv_objdump != x \
   && $gcc_cv_objdump -s -j .eh_frame conftest.o 2>/dev/null \
-     | tail -3 > conftest.got \
+     | tail -n 3 > conftest.got \
   && { cmp conftest.lit conftest.got > /dev/null 2>&1 \
     || cmp conftest.big conftest.got > /dev/null 2>&1; }
   then
diff -Naur gcc-3.4.2.orig/gcc/configure.ac gcc-3.4.2/gcc/configure.ac
--- gcc-3.4.2.orig/gcc/configure.ac	2004-07-13 06:58:29.000000000 +0000
+++ gcc-3.4.2/gcc/configure.ac	2004-09-07 13:55:32.050002160 +0000
@@ -2018,7 +2018,7 @@
   # and we got the correct data, then succeed.
   if test x$gcc_cv_objdump != x \
   && $gcc_cv_objdump -s -j .eh_frame conftest.o 2>/dev/null \
-     | tail -3 > conftest.got \
+     | tail -n 3 > conftest.got \
   && { cmp conftest.lit conftest.got > /dev/null 2>&1 \
     || cmp conftest.big conftest.got > /dev/null 2>&1; }
   then
diff -Naur gcc-3.4.2.orig/libjava/acinclude.m4 gcc-3.4.2/libjava/acinclude.m4
--- gcc-3.4.2.orig/libjava/acinclude.m4	2003-12-31 08:58:29.000000000 +0000
+++ gcc-3.4.2/libjava/acinclude.m4	2004-09-07 13:55:32.056001248 +0000
@@ -250,8 +250,8 @@
 AC_MSG_CHECKING(whether 'ld' is at least 2.13)
 LD_PROG=`$CC --print-prog-name=ld`
 LD_VERSION=`$LD_PROG --version`
-LD_VERSION_MAJOR=`echo "$LD_VERSION" | head -1 | cut -d '.' -f 1 | cut -d ' ' -f 4`
-LD_VERSION_MINOR=`echo "$LD_VERSION" | head -1 | cut -d '.' -f 2`
+LD_VERSION_MAJOR=`echo "$LD_VERSION" | head -n 1 | cut -d '.' -f 1 | cut -d ' ' -f 4`
+LD_VERSION_MINOR=`echo "$LD_VERSION" | head -n 1 | cut -d '.' -f 2`
 if expr "$LD_VERSION_MAJOR" \> 2 > /dev/null; then
   LD_OK="ok"
 else
diff -Naur gcc-3.4.2.orig/libjava/aclocal.m4 gcc-3.4.2/libjava/aclocal.m4
--- gcc-3.4.2.orig/libjava/aclocal.m4	2004-09-06 23:31:35.000000000 +0000
+++ gcc-3.4.2/libjava/aclocal.m4	2004-09-07 13:55:32.082997144 +0000
@@ -262,8 +262,8 @@
 AC_MSG_CHECKING(whether 'ld' is at least 2.13)
 LD_PROG=`$CC --print-prog-name=ld`
 LD_VERSION=`$LD_PROG --version`
-LD_VERSION_MAJOR=`echo "$LD_VERSION" | head -1 | cut -d '.' -f 1 | cut -d ' ' -f 4`
-LD_VERSION_MINOR=`echo "$LD_VERSION" | head -1 | cut -d '.' -f 2`
+LD_VERSION_MAJOR=`echo "$LD_VERSION" | head -n 1 | cut -d '.' -f 1 | cut -d ' ' -f 4`
+LD_VERSION_MINOR=`echo "$LD_VERSION" | head -n 1 | cut -d '.' -f 2`
 if expr "$LD_VERSION_MAJOR" \> 2 > /dev/null; then
   LD_OK="ok"
 else
diff -Naur gcc-3.4.2.orig/libjava/configure gcc-3.4.2/libjava/configure
--- gcc-3.4.2.orig/libjava/configure	2004-09-06 23:31:35.000000000 +0000
+++ gcc-3.4.2/libjava/configure	2004-09-07 13:55:32.162984984 +0000
@@ -3015,8 +3015,8 @@
 echo "configure:3016: checking whether 'ld' is at least 2.13" >&5
 LD_PROG=`$CC --print-prog-name=ld`
 LD_VERSION=`$LD_PROG --version`
-LD_VERSION_MAJOR=`echo "$LD_VERSION" | head -1 | cut -d '.' -f 1 | cut -d ' ' -f 4`
-LD_VERSION_MINOR=`echo "$LD_VERSION" | head -1 | cut -d '.' -f 2`
+LD_VERSION_MAJOR=`echo "$LD_VERSION" | head -n 1 | cut -d '.' -f 1 | cut -d ' ' -f 4`
+LD_VERSION_MINOR=`echo "$LD_VERSION" | head -n 1 | cut -d '.' -f 2`
 if expr "$LD_VERSION_MAJOR" \> 2 > /dev/null; then
   LD_OK="ok"
 else
diff -Naur gcc-3.4.2.orig/libstdc++-v3/acinclude.m4 gcc-3.4.2/libstdc++-v3/acinclude.m4
--- gcc-3.4.2.orig/libstdc++-v3/acinclude.m4	2004-07-15 17:42:45.000000000 +0000
+++ gcc-3.4.2/libstdc++-v3/acinclude.m4	2004-09-07 13:55:33.453788752 +0000
@@ -273,7 +273,7 @@
   # Start by getting the version number.  I think the libtool test already
   # does some of this, but throws away the result.
   changequote(,)
-  ldver=`$LD --version 2>/dev/null | head -1 | \
+  ldver=`$LD --version 2>/dev/null | head -n 1 | \
          sed -e 's/GNU ld version \([0-9.][0-9.]*\).*/\1/'`
   changequote([,])
   glibcxx_gnu_ld_version=`echo $ldver | \
diff -Naur gcc-3.4.2.orig/libstdc++-v3/aclocal.m4 gcc-3.4.2/libstdc++-v3/aclocal.m4
--- gcc-3.4.2.orig/libstdc++-v3/aclocal.m4	2004-08-13 20:44:03.000000000 +0000
+++ gcc-3.4.2/libstdc++-v3/aclocal.m4	2004-09-07 13:55:33.487783584 +0000
@@ -286,7 +286,7 @@
   # Start by getting the version number.  I think the libtool test already
   # does some of this, but throws away the result.
   changequote(,)
-  ldver=`$LD --version 2>/dev/null | head -1 | \
+  ldver=`$LD --version 2>/dev/null | head -n 1 | \
          sed -e 's/GNU ld version \([0-9.][0-9.]*\).*/\1/'`
   changequote([,])
   glibcxx_gnu_ld_version=`echo $ldver | \
diff -Naur gcc-3.4.2.orig/libstdc++-v3/configure gcc-3.4.2/libstdc++-v3/configure
--- gcc-3.4.2.orig/libstdc++-v3/configure	2004-08-13 20:44:04.000000000 +0000
+++ gcc-3.4.2/libstdc++-v3/configure	2004-09-07 13:56:22.282365680 +0000
@@ -7700,7 +7700,7 @@
   # Start by getting the version number.  I think the libtool test already
   # does some of this, but throws away the result.
 
-  ldver=`$LD --version 2>/dev/null | head -1 | \
+  ldver=`$LD --version 2>/dev/null | head -n 1 | \
          sed -e 's/GNU ld version \([0-9.][0-9.]*\).*/\1/'`
 
   glibcxx_gnu_ld_version=`echo $ldver | \
@@ -46876,7 +46876,7 @@
   # Start by getting the version number.  I think the libtool test already
   # does some of this, but throws away the result.
 
-  ldver=`$LD --version 2>/dev/null | head -1 | \
+  ldver=`$LD --version 2>/dev/null | head -n 1 | \
          sed -e 's/GNU ld version \([0-9.][0-9.]*\).*/\1/'`
 
   glibcxx_gnu_ld_version=`echo $ldver | \
@@ -65536,7 +65536,7 @@
   # Start by getting the version number.  I think the libtool test already
   # does some of this, but throws away the result.
 
-  ldver=`$LD --version 2>/dev/null | head -1 | \
+  ldver=`$LD --version 2>/dev/null | head -n 1 | \
          sed -e 's/GNU ld version \([0-9.][0-9.]*\).*/\1/'`
 
   glibcxx_gnu_ld_version=`echo $ldver | \
@@ -67674,7 +67674,7 @@
   # Start by getting the version number.  I think the libtool test already
   # does some of this, but throws away the result.
 
-  ldver=`$LD --version 2>/dev/null | head -1 | \
+  ldver=`$LD --version 2>/dev/null | head -n 1 | \
          sed -e 's/GNU ld version \([0-9.][0-9.]*\).*/\1/'`
 
   glibcxx_gnu_ld_version=`echo $ldver | \
@@ -69688,7 +69688,7 @@
   # Start by getting the version number.  I think the libtool test already
   # does some of this, but throws away the result.
 
-  ldver=`$LD --version 2>/dev/null | head -1 | \
+  ldver=`$LD --version 2>/dev/null | head -n 1 | \
          sed -e 's/GNU ld version \([0-9.][0-9.]*\).*/\1/'`
 
   glibcxx_gnu_ld_version=`echo $ldver | \
@@ -72414,7 +72414,7 @@
   # Start by getting the version number.  I think the libtool test already
   # does some of this, but throws away the result.
 
-  ldver=`$LD --version 2>/dev/null | head -1 | \
+  ldver=`$LD --version 2>/dev/null | head -n 1 | \
          sed -e 's/GNU ld version \([0-9.][0-9.]*\).*/\1/'`
 
   glibcxx_gnu_ld_version=`echo $ldver | \
@@ -74381,7 +74381,7 @@
   # Start by getting the version number.  I think the libtool test already
   # does some of this, but throws away the result.
 
-  ldver=`$LD --version 2>/dev/null | head -1 | \
+  ldver=`$LD --version 2>/dev/null | head -n 1 | \
          sed -e 's/GNU ld version \([0-9.][0-9.]*\).*/\1/'`
 
   glibcxx_gnu_ld_version=`echo $ldver | \
@@ -76247,7 +76247,7 @@
   # Start by getting the version number.  I think the libtool test already
   # does some of this, but throws away the result.
 
-  ldver=`$LD --version 2>/dev/null | head -1 | \
+  ldver=`$LD --version 2>/dev/null | head -n 1 | \
          sed -e 's/GNU ld version \([0-9.][0-9.]*\).*/\1/'`
 
   glibcxx_gnu_ld_version=`echo $ldver | \
@@ -79926,7 +79926,7 @@
   # Start by getting the version number.  I think the libtool test already
   # does some of this, but throws away the result.
 
-  ldver=`$LD --version 2>/dev/null | head -1 | \
+  ldver=`$LD --version 2>/dev/null | head -n 1 | \
          sed -e 's/GNU ld version \([0-9.][0-9.]*\).*/\1/'`
 
   glibcxx_gnu_ld_version=`echo $ldver | \
diff -Naur gcc-3.4.2.orig/libstdc++-v3/scripts/check_survey.in gcc-3.4.2/libstdc++-v3/scripts/check_survey.in
--- gcc-3.4.2.orig/libstdc++-v3/scripts/check_survey.in	2003-07-05 06:00:05.000000000 +0000
+++ gcc-3.4.2/libstdc++-v3/scripts/check_survey.in	2004-09-07 13:55:32.171983616 +0000
@@ -182,9 +182,9 @@
     function size_command()
     {
       case $1 in
-        TEXT)  TEXT=$(size -B $EXENAME | tail -1 | awk '{print $1}')  ;;
-        DATA)  DATA=$(size -B $EXENAME | tail -1 | awk '{print $2}')  ;;
-        SIZE)  SIZE=$(size -B $EXENAME | tail -1 | awk '{print $4}')  ;;
+        TEXT)  TEXT=$(size -B $EXENAME | tail -n 1 | awk '{print $1}')  ;;
+        DATA)  DATA=$(size -B $EXENAME | tail -n 1 | awk '{print $2}')  ;;
+        SIZE)  SIZE=$(size -B $EXENAME | tail -n 1 | awk '{print $4}')  ;;
       esac
     }
   else
diff -Naur gcc-3.4.2.orig/ltcf-c.sh gcc-3.4.2/ltcf-c.sh
--- gcc-3.4.2.orig/ltcf-c.sh	2003-11-19 05:29:32.000000000 +0000
+++ gcc-3.4.2/ltcf-c.sh	2004-09-07 13:55:33.503781152 +0000
@@ -153,7 +153,7 @@
     # If the export-symbols file already is a .def file (1st line
     # is EXPORTS), use it as is.
     # If DATA tags from a recent dlltool are present, honour them!
-    archive_expsym_cmds='if test "x`head -1 $export_symbols`" = xEXPORTS; then
+    archive_expsym_cmds='if test "x`head -n 1 $export_symbols`" = xEXPORTS; then
         cp $export_symbols $output_objdir/$soname-def;
       else
         echo EXPORTS > $output_objdir/$soname-def;
diff -Naur gcc-3.4.2.orig/ltcf-gcj.sh gcc-3.4.2/ltcf-gcj.sh
--- gcc-3.4.2.orig/ltcf-gcj.sh	2003-11-19 05:29:32.000000000 +0000
+++ gcc-3.4.2/ltcf-gcj.sh	2004-09-07 13:55:33.496782216 +0000
@@ -156,7 +156,7 @@
     # If the export-symbols file already is a .def file (1st line
     # is EXPORTS), use it as is.
     # If DATA tags from a recent dlltool are present, honour them!
-    archive_expsym_cmds='if test "x`head -1 $export_symbols`" = xEXPORTS; then
+    archive_expsym_cmds='if test "x`head -n 1 $export_symbols`" = xEXPORTS; then
         cp $export_symbols $output_objdir/$soname-def;
       else
         echo EXPORTS > $output_objdir/$soname-def;